document.addEventListener('DOMContentLoaded', function() {
  var $skip = document.querySelector('#skip');
  var $subscribeForm = document.querySelector('#subscribe-form');
  var email = new Email();

  $subscribeForm.addEventListener('submit', function(e) {
    e.preventDefault();
    email.validEmail();
  });
});

var Email = function(opt) {
  this.email = '';
  this.init();
};

Email.prototype.init = function() {
  var self = this;
  this.$field = document.querySelector('#subscribe-form-email');
  this.$field.addEventListener('click', function(e) {
    self.setErrorClass('remove');
  });
  this.$field.addEventListener('keyup', function() {
    self.setErrorClass('remove');
  });
};

Email.prototype.validEmail = function() {
  var email = this.$field.value;
  var regEmail = /^([a-z0-9_\-]+\.)*[a-z0-9_\-]+[\+a-z0-9]*@([a-z0-9][a-z0-9\-]*[a-z0-9]\.)+[a-z]{2,4}$/i;
  if (regEmail.test(email)) {
    this.setErrorClass('remove');
    this.sendEmail(email);
  } else {
    this.setErrorClass('add');
  }
  this.$field.focus();
};

Email.prototype.sendEmail = function(email) {
  document.querySelector('#loader').classList.add('-loading');
  __sendEmail(email);
};

Email.prototype.setErrorClass = function(type) {
  if (type === 'add') {
    this.$field.classList.add('error');
  } else if (type === 'remove') {
    this.$field.classList.remove('error');
  }
};

function subscribeHandler(type) {
  var $subscribeForm = document.querySelector('#subscribe-form');
  var $okMessage = document.querySelector('.thank-you-message.ok');
  var $falseMessage = document.querySelector('.thank-you-message.error');
  $subscribeForm.classList.add('successful-subscribe');

  document.querySelector('#loader').classList.remove('-loading');

  if (type === 'ok') {
    $okMessage.style.display = "block";
  } else if (type === 'error') {
    $falseMessage.style.display = "block";
  }
}

function __launch() {
  if (typeof(controller) !== 'undefined') controller.launch();
}

function __sendEmail(email) {
  if (typeof(controller) !== 'undefined') controller.email_(email);
}